/*********************************************
* File:   Generic_func.c                     *
* Autori: ing. Marco Gottardo                *
*         ing. Riccardo Costacurta           *
*                                            *
* Sviluppato per piattaforma Micro-GT IDE    *
*         MCU: PIC16F877A                    *
*         6 Marzo 2014                       *
*                                            *
* Funzioni di uso generale                   *
*(abbinare a generic_func.h)                 *
*Abilita due canali PWM su RC1 e RC2         *
*Il controllo avviene tramite potenziometro  *
*sul canale AN0 e due pulsanti di aumente e  *
*diminuisce su RD0 e RD1                     *
********************************************/
#define _LEGACY_HEADERS  // permette di acquisire la sintassi dei compilatori precedenti

#include"htc.h"
#include<pic.h>
#include "delay.h"
// #include "generic_func.h"

__CONFIG (HS & WDTEN & PWRTDIS & BORDIS & LVPDIS & DUNPROT & WRTEN & DEBUGDIS & UNPROTECT);//Fuses

void configuraApp()
{
    TRISA=0x11111011;
    // TRISB=0b00000000;
    // TRISC=0b01111000;            //primo nibble output, lascio libera la seriale
    //TRISD=0;
    //TRISE=0;
    //PORTD=0;
    //PORTE=0;
    // OPTION=0b00000000;
    ADCON1=0b00000100;   // Cfg con A4 input digitale
    ADCON1 = 0b10000100;    // Attenzione al bit 7 a 1 - altrimenti la lettura ADC va a farfalle
    // CMCON=0b00000111;       // Comparatori off
}

int leggi_ad(char canale)
{
    int valore;

    ADCON0 = (canale << 3) + 0xC1;	// enable ADC, RC osc + 193 ovvero il 193 setta il clock .
    DelayUs(10);			//Ritardo per dare modo all'A/D di stabilizzarsi
    ADGO = 1;      			//Fa partire la conversione
    while(ADGO)
	continue;	//Attende che la conversione sia completa
    valore=ADRESL;      		//Parte bassa del risultato
    valore= valore + (ADRESH<<8);  	//Parte alta del risultato
    return(valore);
}
